using Indotalent.Data.Entities;
using Indotalent.Shared.Consts;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;

namespace Indotalent.Infrastructure.Database.MsSQL.Configuration;

public class CreditNoteConfiguration : IEntityTypeConfiguration<CreditNote>
{
    public void Configure(EntityTypeBuilder<CreditNote> builder)
    {
        builder.Property(e => e.AutoNumber)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.Description)
            .HasMaxLength(GlobalConsts.StringLengthMedium);

        builder.Property(e => e.SalesReturnId)
            .HasMaxLength(GlobalConsts.StringLengthId);

        builder.HasOne(e => e.SalesReturn)
            .WithMany()
            .HasForeignKey(e => e.SalesReturnId)
            .OnDelete(DeleteBehavior.NoAction);

        builder.HasIndex(e => new { e.TenantId, e.AutoNumber }).IsUnique();
        builder.HasIndex(e => e.CreditNoteDate);
        builder.HasIndex(e => e.SalesReturnId);
    }
}